Index: uspace/srv/hw/irc/fhc/fhc.c
===================================================================
--- uspace/srv/hw/irc/fhc/fhc.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/hw/irc/fhc/fhc.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -136,5 +136,5 @@
 	
 	async_set_client_connection(fhc_connection);
-	service_register(SERVICE_IRC);
+	service_register(SERVICE_FHC);
 	
 	return true;
Index: uspace/srv/hw/irc/i8259/i8259.c
===================================================================
--- uspace/srv/hw/irc/i8259/i8259.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/hw/irc/i8259/i8259.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -149,5 +149,5 @@
 	
 	async_set_client_connection(i8259_connection);
-	service_register(SERVICE_IRC);
+	service_register(SERVICE_I8259);
 	
 	return true;
Index: uspace/srv/hw/irc/obio/obio.c
===================================================================
--- uspace/srv/hw/irc/obio/obio.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/hw/irc/obio/obio.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -137,5 +137,5 @@
 	
 	async_set_client_connection(obio_connection);
-	service_register(SERVICE_IRC);
+	service_register(SERVICE_OBIO);
 	
 	return true;
Index: uspace/srv/hw/netif/ne2000/dp8390.c
===================================================================
--- uspace/srv/hw/netif/ne2000/dp8390.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/hw/netif/ne2000/dp8390.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -391,5 +391,4 @@
 	
 	if ((size < ETH_MIN_PACK_SIZE) || (size > ETH_MAX_PACK_SIZE_TAGGED)) {
-		fibril_mutex_unlock(&ne2k->sq_mutex);
 		fprintf(stderr, "%s: Frame dropped (invalid size %zu bytes)\n",
 		    NAME, size);
Index: uspace/srv/hw/netif/ne2000/ne2000.c
===================================================================
--- uspace/srv/hw/netif/ne2000/ne2000.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/hw/netif/ne2000/ne2000.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -75,5 +75,5 @@
 #define IRQ_GET_TSR(call)  ((int) IPC_GET_ARG3(call))
 
-static bool irc_service = false;
+static int irc_service = 0;
 static int irc_phone = -1;
 
@@ -383,11 +383,12 @@
 	sysarg_t i8259;
 	
-	if (((sysinfo_get_value("apic", &apic) == EOK) && (apic))
-	    || ((sysinfo_get_value("i8259", &i8259) == EOK) && (i8259)))
-		irc_service = true;
+	if ((sysinfo_get_value("apic", &apic) == EOK) && (apic))
+		irc_service = SERVICE_APIC;
+	else if ((sysinfo_get_value("i8259", &i8259) == EOK) && (i8259))
+		irc_service = SERVICE_I8259;
 	
 	if (irc_service) {
 		while (irc_phone < 0)
-			irc_phone = service_connect_blocking(SERVICE_IRC, 0, 0);
+			irc_phone = service_connect_blocking(irc_service, 0, 0);
 	}
 	
Index: uspace/srv/loader/arch/abs32le/_link.ld.in
===================================================================
--- uspace/srv/loader/arch/abs32le/_link.ld.in	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/loader/arch/abs32le/_link.ld.in	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -21,6 +21,6 @@
 	
 	.text : {
-		*(.text .text.*);
-		*(.rodata .rodata.*);
+		*(.text);
+		*(.rodata*);
 	} :text
 	
Index: uspace/srv/loader/arch/amd64/_link.ld.in
===================================================================
--- uspace/srv/loader/arch/amd64/_link.ld.in	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/loader/arch/amd64/_link.ld.in	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -27,6 +27,6 @@
 	
 	.text : {
-		*(.text .text.*);
-		*(.rodata .rodata.*);
+		*(.text);
+		*(.rodata*);
 	} :text
 	
Index: uspace/srv/loader/arch/arm32/_link.ld.in
===================================================================
--- uspace/srv/loader/arch/arm32/_link.ld.in	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/loader/arch/arm32/_link.ld.in	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -25,6 +25,6 @@
 	
 	.text : {
-		*(.text .text.*);
-		*(.rodata .rodata.*);
+		*(.text);
+		*(.rodata*);
 	} :text
 	
Index: uspace/srv/loader/arch/ia32/_link.ld.in
===================================================================
--- uspace/srv/loader/arch/ia32/_link.ld.in	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/loader/arch/ia32/_link.ld.in	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -26,6 +26,6 @@
 	
 	.text : {
-		*(.text .text.*);
-		*(.rodata .rodata.*);
+		*(.text);
+		*(.rodata*);
 	} :text
 	
Index: uspace/srv/loader/arch/ia64/_link.ld.in
===================================================================
--- uspace/srv/loader/arch/ia64/_link.ld.in	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/loader/arch/ia64/_link.ld.in	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -21,6 +21,6 @@
 	
 	.text : {
-		*(.text .text.*);
-		*(.rodata .rodata.*);
+		*(.text);
+		*(.rodata*);
 	} :text
 	
@@ -29,5 +29,5 @@
 	.got : {
 		_gp = .;
-		*(.got .got.*);
+		*(.got*);
 	} :data
 	
Index: uspace/srv/loader/arch/mips32/_link.ld.in
===================================================================
--- uspace/srv/loader/arch/mips32/_link.ld.in	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/loader/arch/mips32/_link.ld.in	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -25,6 +25,6 @@
 	
 	.text : {
-		*(.text .text.*);
-		*(.rodata .rodata.*);
+		*(.text);
+		*(.rodata*);
 	} :text
 	
Index: uspace/srv/loader/arch/ppc32/_link.ld.in
===================================================================
--- uspace/srv/loader/arch/ppc32/_link.ld.in	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/loader/arch/ppc32/_link.ld.in	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -25,6 +25,6 @@
 	
 	.text : {
-		*(.text .text.*);
-		*(.rodata .rodata.*);
+		*(.text);
+		*(.rodata*);
 	} :text
 	
Index: uspace/srv/loader/arch/sparc64/_link.ld.in
===================================================================
--- uspace/srv/loader/arch/sparc64/_link.ld.in	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/loader/arch/sparc64/_link.ld.in	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -20,6 +20,6 @@
 	
 	.text : {
-		*(.text .text.*);
-		*(.rodata .rodata.*);
+		*(.text);
+		*(.rodata*);
 	} :text
 	
Index: uspace/srv/loader/main.c
===================================================================
--- uspace/srv/loader/main.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/loader/main.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -415,10 +415,12 @@
 			/* Not reached */
 		default:
-			retval = EINVAL;
+			retval = ENOENT;
 			break;
 		}
-		
-		if (IPC_GET_IMETHOD(call) != IPC_M_PHONE_HUNGUP)
-			async_answer_0(callid, retval);
+		if (IPC_GET_IMETHOD(call) != IPC_M_PHONE_HUNGUP) {
+			DPRINTF("Responding EINVAL to method %d.\n",
+			    IPC_GET_IMETHOD(call));
+			async_answer_0(callid, EINVAL);
+		}
 	}
 }
Index: uspace/srv/net/il/arp/arp.c
===================================================================
--- uspace/srv/net/il/arp/arp.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/net/il/arp/arp.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -157,9 +157,9 @@
 			
 			arp_clear_addr(&proto->addresses);
-			arp_addr_destroy(&proto->addresses, free);
-		}
-	}
-	
-	arp_protos_clear(&device->protos, free);
+			arp_addr_destroy(&proto->addresses);
+		}
+	}
+	
+	arp_protos_clear(&device->protos);
 }
 
@@ -184,5 +184,5 @@
 	}
 	
-	arp_cache_clear(&arp_globals.cache, free);
+	arp_cache_clear(&arp_globals.cache);
 	fibril_mutex_unlock(&arp_globals.lock);
 	
@@ -212,5 +212,5 @@
 		arp_clear_trans(trans);
 	
-	arp_addr_exclude(&proto->addresses, address->value, address->length, free);
+	arp_addr_exclude(&proto->addresses, address->value, address->length);
 	
 	fibril_mutex_unlock(&arp_globals.lock);
@@ -345,5 +345,5 @@
 			    header->protocol_length, trans);
 			if (rc != EOK) {
-				free(trans);
+				/* The generic char map has already freed trans! */
 				return rc;
 			}
@@ -556,5 +556,5 @@
 		if (index < 0) {
 			fibril_mutex_unlock(&arp_globals.lock);
-			arp_protos_destroy(&device->protos, free);
+			arp_protos_destroy(&device->protos);
 			free(device);
 			return index;
@@ -569,5 +569,5 @@
 		if (device->phone < 0) {
 			fibril_mutex_unlock(&arp_globals.lock);
-			arp_protos_destroy(&device->protos, free);
+			arp_protos_destroy(&device->protos);
 			free(device);
 			return EREFUSED;
@@ -579,5 +579,5 @@
 		if (rc != EOK) {
 			fibril_mutex_unlock(&arp_globals.lock);
-			arp_protos_destroy(&device->protos, free);
+			arp_protos_destroy(&device->protos);
 			free(device);
 			return rc;
@@ -589,5 +589,5 @@
 		if (rc != EOK) {
 			fibril_mutex_unlock(&arp_globals.lock);
-			arp_protos_destroy(&device->protos, free);
+			arp_protos_destroy(&device->protos);
 			free(device);
 			return rc;
@@ -601,5 +601,5 @@
 			free(device->addr);
 			free(device->addr_data);
-			arp_protos_destroy(&device->protos, free);
+			arp_protos_destroy(&device->protos);
 			free(device);
 			return rc;
@@ -614,5 +614,5 @@
 			free(device->broadcast_addr);
 			free(device->broadcast_data);
-			arp_protos_destroy(&device->protos, free);
+			arp_protos_destroy(&device->protos);
 			free(device);
 			return rc;
@@ -746,5 +746,5 @@
 			arp_clear_trans(trans);
 			arp_addr_exclude(&proto->addresses, target->value,
-			    target->length, free);
+			    target->length);
 			return EAGAIN;
 		}
@@ -794,5 +794,5 @@
 	    trans);
 	if (rc != EOK) {
-		free(trans);
+		/* The generic char map has already freed trans! */
 		return rc;
 	}
@@ -807,5 +807,5 @@
 		arp_clear_trans(trans);
 		arp_addr_exclude(&proto->addresses, target->value,
-		    target->length, free);
+		    target->length);
 		return ENOENT;
 	}
Index: uspace/srv/net/il/ip/ip.c
===================================================================
--- uspace/srv/net/il/ip/ip.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/net/il/ip/ip.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -176,5 +176,5 @@
 	socklen_t addrlen;
 
-	/* Detach the first packet and release the others */
+	// detach the first packet and release the others
 	next = pq_detach(packet);
 	if (next)
@@ -185,5 +185,5 @@
 			return ENOMEM;
 
-		/* Get header */
+		// get header
 		header = (ip_header_t *) packet_get_data(packet);
 		if (!header)
@@ -192,13 +192,13 @@
 	}
 
-	/* Only for the first fragment */
+	// only for the first fragment
 	if (IP_FRAGMENT_OFFSET(header))
 		return EINVAL;
 
-	/* Not for the ICMP protocol */
+	// not for the ICMP protocol
 	if (header->protocol == IPPROTO_ICMP)
 		return EPERM;
 
-	/* Set the destination address */
+	// set the destination address
 	switch (header->version) {
 	case IPVERSION:
@@ -351,5 +351,5 @@
 	configuration = &names[0];
 
-	/* Get configuration */
+	// get configuration
 	rc = net_get_device_conf_req(ip_globals.net_phone, ip_netif->device_id,
 	    &configuration, count, &data);
@@ -365,5 +365,5 @@
 		
 		if (ip_netif->dhcp) {
-			/* TODO dhcp */
+			// TODO dhcp
 			net_free_settings(configuration, data);
 			return ENOTSUP;
@@ -398,5 +398,5 @@
 			}
 		} else {
-			/* TODO ipv6 in separate module */
+			// TODO ipv6 in separate module
 			net_free_settings(configuration, data);
 			return ENOTSUP;
@@ -419,5 +419,5 @@
 	}
 
-	/* Bind netif service which also initializes the device */
+	// binds the netif service which also initializes the device
 	ip_netif->phone = nil_bind_service(ip_netif->service,
 	    (sysarg_t) ip_netif->device_id, SERVICE_IP,
@@ -429,5 +429,5 @@
 	}
 
-	/* Has to be after the device netif module initialization */
+	// has to be after the device netif module initialization
 	if (ip_netif->arp) {
 		if (route) {
@@ -445,5 +445,5 @@
 	}
 
-	/* Get packet dimensions */
+	// get packet dimensions
 	rc = nil_packet_size_req(ip_netif->phone, ip_netif->device_id,
 	    &ip_netif->packet_dimension);
@@ -463,5 +463,5 @@
 	
 	if (gateway.s_addr) {
-		/* The default gateway */
+		// the default gateway
 		ip_globals.gateway.address.s_addr = 0;
 		ip_globals.gateway.netmask.s_addr = 0;
@@ -505,5 +505,5 @@
 	if (rc != EOK) {
 		fibril_rwlock_write_unlock(&ip_globals.netifs_lock);
-		ip_routes_destroy(&ip_netif->routes, free);
+		ip_routes_destroy(&ip_netif->routes);
 		free(ip_netif);
 		return rc;
@@ -512,10 +512,10 @@
 		ip_netif->arp->usage++;
 
-	/* Print the settings */
+	// print the settings
 	printf("%s: Device registered (id: %d, phone: %d, ipv: %d, conf: %s)\n",
 	    NAME, ip_netif->device_id, ip_netif->phone, ip_netif->ipv,
 	    ip_netif->dhcp ? "dhcp" : "static");
 	
-	/* TODO ipv6 addresses */
+	// TODO ipv6 addresses
 	
 	char address[INET_ADDRSTRLEN];
@@ -587,5 +587,5 @@
 	ip_netif_t *netif;
 
-	/* Start with the last netif - the newest one */
+	// start with the last netif - the newest one
 	index = ip_netifs_count(&ip_globals.netifs) - 1;
 	while (index >= 0) {
@@ -629,18 +629,18 @@
 	size_t length;
 
-	/* Copy first itself */
+	// copy first itself
 	memcpy(last, first, sizeof(ip_header_t));
 	length = sizeof(ip_header_t);
 	next = sizeof(ip_header_t);
 
-	/* Process all IP options */
+	// process all ip options
 	while (next < first->header_length) {
 		option = (ip_option_t *) (((uint8_t *) first) + next);
-		/* Skip end or noop */
+		// skip end or noop
 		if ((option->type == IPOPT_END) ||
 		    (option->type == IPOPT_NOOP)) {
 			next++;
 		} else {
-			/* Copy if told so or skip */
+			// copy if told so or skip
 			if (IPOPT_COPIED(option->type)) {
 				memcpy(((uint8_t *) last) + length,
@@ -648,10 +648,10 @@
 				length += option->length;
 			}
-			/* Next option */
+			// next option
 			next += option->length;
 		}
 	}
 
-	/* Align 4 byte boundary */
+	// align 4 byte boundary
 	if (length % 4) {
 		bzero(((uint8_t *) last) + length, 4 - (length % 4));
@@ -789,5 +789,5 @@
 
 	header->total_length = htons(length);
-	/* Unnecessary for all protocols */
+	// unnecessary for all protocols
 	header->header_checksum = IP_HEADER_CHECKSUM(header);
 
@@ -916,14 +916,14 @@
 		return ENOMEM;
 
-	/* Get header */
+	// get header
 	header = (ip_header_t *) packet_get_data(packet);
 	if (!header)
 		return EINVAL;
 
-	/* Fragmentation forbidden? */
+	// fragmentation forbidden?
 	if(header->flags & IPFLAG_DONT_FRAGMENT)
 		return EPERM;
 
-	/* Create the last fragment */
+	// create the last fragment
 	new_packet = packet_get_4_remote(ip_globals.net_phone, prefix, length,
 	    suffix, ((addrlen > addr_len) ? addrlen : addr_len));
@@ -931,5 +931,5 @@
 		return ENOMEM;
 
-	/* Allocate as much as originally */
+	// allocate as much as originally
 	last_header = (ip_header_t *) packet_suffix(new_packet,
 	    IP_HEADER_LENGTH(header));
@@ -939,5 +939,5 @@
 	ip_create_last_header(last_header, header);
 
-	/* Trim the unused space */
+	// trim the unused space
 	rc = packet_trim(new_packet, 0,
 	    IP_HEADER_LENGTH(header) - IP_HEADER_LENGTH(last_header));
@@ -945,6 +945,6 @@
 		return ip_release_and_return(packet, rc);
 
-	/* Greatest multiple of 8 lower than content */
-	/* TODO even fragmentation? */
+	// biggest multiple of 8 lower than content
+	// TODO even fragmentation?
 	length = length & ~0x7;
 	
@@ -957,8 +957,8 @@
 		return ip_release_and_return(packet, rc);
 
-	/* Mark the first as fragmented */
+	// mark the first as fragmented
 	header->flags |= IPFLAG_MORE_FRAGMENTS;
 
-	/* Create middle fragments */
+	// create middle framgents
 	while (IP_TOTAL_LENGTH(header) > length) {
 		new_packet = packet_get_4_remote(ip_globals.net_phone, prefix,
@@ -981,5 +981,5 @@
 	}
 
-	/* Finish the first fragment */
+	// finish the first fragment
 	header->header_checksum = IP_HEADER_CHECKSUM(header);
 
@@ -1012,5 +1012,5 @@
 
 	next = packet;
-	/* Check all packets */
+	// check all packets
 	while (next) {
 		length = packet_get_data_length(next);
@@ -1021,5 +1021,5 @@
 		}
 
-		/* Too long */
+		// too long
 		result = ip_fragment_packet(next, content, prefix,
 		    suffix, addr_len);
@@ -1027,13 +1027,13 @@
 			new_packet = pq_detach(next);
 			if (next == packet) {
-				/* The new first packet of the queue */
+				// the new first packet of the queue
 				packet = new_packet;
 			}
-			/* Fragmentation needed? */
+			// fragmentation needed?
 			if (result == EPERM) {
 				phone = ip_prepare_icmp_and_get_phone(
 				    error, next, NULL);
 				if (phone >= 0) {
-					/* Fragmentation necessary ICMP */
+					// fragmentation necessary ICMP
 					icmp_destination_unreachable_msg(phone,
 					    ICMP_FRAG_NEEDED, content, next);
@@ -1080,5 +1080,5 @@
 	int rc;
 
-	/* Get destination hardware address */
+	// get destination hardware address
 	if (netif->arp && (route->address.s_addr != dest.s_addr)) {
 		destination.value = route->gateway.s_addr ?
@@ -1102,5 +1102,5 @@
 			    NULL);
 			if (phone >= 0) {
-				/* Unreachable ICMP if no routing */
+				// unreachable ICMP if no routing
 				icmp_destination_unreachable_msg(phone,
 				    ICMP_HOST_UNREACH, 0, packet);
@@ -1148,8 +1148,6 @@
 	int rc;
 
-	/*
-	 * Addresses in the host byte order
-	 * Should be the next hop address or the target destination address
-	 */
+	// addresses in the host byte order
+	// should be the next hop address or the target destination address
 	addrlen = packet_get_addr(packet, NULL, (uint8_t **) &addr);
 	if (addrlen < 0)
@@ -1176,5 +1174,5 @@
 	fibril_rwlock_read_lock(&ip_globals.netifs_lock);
 
-	/* Device specified? */
+	// device specified?
 	if (device_id > 0) {
 		netif = ip_netifs_find(&ip_globals.netifs, device_id);
@@ -1192,5 +1190,5 @@
 		phone = ip_prepare_icmp_and_get_phone(error, packet, NULL);
 		if (phone >= 0) {
-			/* Unreachable ICMP if no routing */
+			// unreachable ICMP if no routing
 			icmp_destination_unreachable_msg(phone,
 			    ICMP_NET_UNREACH, 0, packet);
@@ -1200,8 +1198,6 @@
 
 	if (error) {
-		/*
-		 * Do not send for broadcast, anycast packets or network
-		 * broadcast.
-		 */
+		// do not send for broadcast, anycast packets or network
+		// broadcast
 		if (!dest->s_addr || !(~dest->s_addr) ||
 		    !(~((dest->s_addr & ~route->netmask.s_addr) |
@@ -1212,8 +1208,8 @@
 	}
 	
-	/* Ff the local host is the destination */
+	// if the local host is the destination
 	if ((route->address.s_addr == dest->s_addr) &&
 	    (dest->s_addr != IPV4_LOCALHOST_ADDRESS)) {
-		/* Find the loopback device to deliver */
+		// find the loopback device to deliver
 		dest->s_addr = IPV4_LOCALHOST_ADDRESS;
 		route = ip_find_route(*dest);
@@ -1224,5 +1220,5 @@
 			    NULL);
 			if (phone >= 0) {
-				/* Unreachable ICMP if no routing */
+				// unreachable ICMP if no routing
 				icmp_destination_unreachable_msg(phone,
 				    ICMP_HOST_UNREACH, 0, packet);
@@ -1256,5 +1252,5 @@
 
 	fibril_rwlock_write_lock(&ip_globals.netifs_lock);
-	/* Find the device */
+	// find the device
 	netif = ip_netifs_find(&ip_globals.netifs, device_id);
 	if (!netif) {
@@ -1279,5 +1275,5 @@
 	in_addr_t destination;
 
-	/* TODO search set ipopt route? */
+	// TODO search set ipopt route?
 	destination.s_addr = header->destination_address;
 	return destination;
@@ -1321,5 +1317,5 @@
 	if ((header->flags & IPFLAG_MORE_FRAGMENTS) ||
 	    IP_FRAGMENT_OFFSET(header)) {
-		/* TODO fragmented */
+		// TODO fragmented
 		return ENOTSUP;
 	}
@@ -1348,5 +1344,5 @@
 		return ip_release_and_return(packet, rc);
 
-	/* Trim padding if present */
+	// trim padding if present
 	if (!error &&
 	    (IP_TOTAL_LENGTH(header) < packet_get_data_length(packet))) {
@@ -1364,5 +1360,5 @@
 		phone = ip_prepare_icmp_and_get_phone(error, packet, header);
 		if (phone >= 0) {
-			/* Unreachable ICMP */
+			// unreachable ICMP
 			icmp_destination_unreachable_msg(phone,
 			    ICMP_PROT_UNREACH, 0, packet);
@@ -1421,10 +1417,10 @@
 		return ip_release_and_return(packet, ENOMEM);
 
-	/* Checksum */
+	// checksum
 	if ((header->header_checksum) &&
 	    (IP_HEADER_CHECKSUM(header) != IP_CHECKSUM_ZERO)) {
 		phone = ip_prepare_icmp_and_get_phone(0, packet, header);
 		if (phone >= 0) {
-			/* Checksum error ICMP */
+			// checksum error ICMP
 			icmp_parameter_problem_msg(phone, ICMP_PARAM_POINTER,
 			    ((size_t) ((void *) &header->header_checksum)) -
@@ -1437,5 +1433,5 @@
 		phone = ip_prepare_icmp_and_get_phone(0, packet, header);
 		if (phone >= 0) {
-			/* ttl exceeded ICMP */
+			// ttl exceeded ICMP
 			icmp_time_exceeded_msg(phone, ICMP_EXC_TTL, packet);
 		}
@@ -1443,8 +1439,8 @@
 	}
 	
-	/* Process ipopt and get destination */
+	// process ipopt and get destination
 	dest = ip_get_destination(header);
 
-	/* Set the destination address */
+	// set the addrination address
 	switch (header->version) {
 	case IPVERSION:
@@ -1468,5 +1464,5 @@
 		phone = ip_prepare_icmp_and_get_phone(0, packet, header);
 		if (phone >= 0) {
-			/* Unreachable ICMP */
+			// unreachable ICMP
 			icmp_destination_unreachable_msg(phone,
 			    ICMP_HOST_UNREACH, 0, packet);
@@ -1476,5 +1472,5 @@
 
 	if (route->address.s_addr == dest.s_addr) {
-		/* Local delivery */
+		// local delivery
 		return ip_deliver_local(device_id, packet, header, 0);
 	}
@@ -1488,5 +1484,5 @@
 	phone = ip_prepare_icmp_and_get_phone(0, packet, header);
 	if (phone >= 0) {
-		/* Unreachable ICMP if no routing */
+		// unreachable ICMP if no routing
 		icmp_destination_unreachable_msg(phone, ICMP_HOST_UNREACH, 0,
 		    packet);
@@ -1774,8 +1770,8 @@
 		header = (ip_header_t *)(data + offset);
 
-		/* Destination host unreachable? */
+		// destination host unreachable?
 		if ((type != ICMP_DEST_UNREACH) ||
 		    (code != ICMP_HOST_UNREACH)) {
-		    	/* No, something else */
+		    	// no, something else
 			break;
 		}
@@ -1791,8 +1787,8 @@
 		route = ip_routes_get_index(&netif->routes, 0);
 
-		/* From the same network? */
+		// from the same network?
 		if (route && ((route->address.s_addr & route->netmask.s_addr) ==
 		    (header->destination_address & route->netmask.s_addr))) {
-			/* Clear the ARP mapping if any */
+			// clear the ARP mapping if any
 			address.value = (uint8_t *) &header->destination_address;
 			address.length = sizeof(header->destination_address);
@@ -1848,8 +1844,8 @@
 	fibril_rwlock_read_lock(&ip_globals.lock);
 	route = ip_find_route(*dest);
-	/* If the local host is the destination */
+	// if the local host is the destination
 	if (route && (route->address.s_addr == dest->s_addr) &&
 	    (dest->s_addr != IPV4_LOCALHOST_ADDRESS)) {
-		/* Find the loopback device to deliver */
+		// find the loopback device to deliver
 		dest->s_addr = IPV4_LOCALHOST_ADDRESS;
 		route = ip_find_route(*dest);
Index: uspace/srv/net/net/net.c
===================================================================
--- uspace/srv/net/net/net.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/net/net/net.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -289,15 +289,12 @@
 	if (rc != EOK)
 		return rc;
-	
 	rc = add_module(NULL, &net_globals.modules, (uint8_t *) NE2000_NAME,
 	    (uint8_t *) NE2000_FILENAME, SERVICE_NE2000, 0, connect_to_service);
 	if (rc != EOK)
 		return rc;
-	
 	rc = add_module(NULL, &net_globals.modules, (uint8_t *) ETHERNET_NAME,
 	    (uint8_t *) ETHERNET_FILENAME, SERVICE_ETHERNET, 0, connect_to_service);
 	if (rc != EOK)
 		return rc;
-	
 	rc = add_module(NULL, &net_globals.modules, (uint8_t *) NILDUMMY_NAME,
 	    (uint8_t *) NILDUMMY_FILENAME, SERVICE_NILDUMMY, 0, connect_to_service);
@@ -555,5 +552,5 @@
 		rc = read_netif_configuration(conf_files[i], netif);
 		if (rc != EOK) {
-			measured_strings_destroy(&netif->configuration, free);
+			measured_strings_destroy(&netif->configuration);
 			free(netif);
 			return rc;
@@ -565,5 +562,5 @@
 		if (!setting) {
 			fprintf(stderr, "%s: Network interface name is missing\n", NAME);
-			measured_strings_destroy(&netif->configuration, free);
+			measured_strings_destroy(&netif->configuration);
 			free(netif);
 			return EINVAL;
@@ -574,5 +571,5 @@
 		int index = netifs_add(&net_globals.netifs, netif->id, netif);
 		if (index < 0) {
-			measured_strings_destroy(&netif->configuration, free);
+			measured_strings_destroy(&netif->configuration);
 			free(netif);
 			return index;
@@ -586,6 +583,6 @@
 		    index);
 		if (rc != EOK) {
-			measured_strings_destroy(&netif->configuration, free);
-			netifs_exclude_index(&net_globals.netifs, index, free);
+			measured_strings_destroy(&netif->configuration);
+			netifs_exclude_index(&net_globals.netifs, index);
 			return rc;
 		}
@@ -593,9 +590,10 @@
 		rc = start_device(netif);
 		if (rc != EOK) {
-			printf("%s: Ignoring failed interface %s (%s)\n", NAME,
+			printf("%s: Error starting interface %s (%s)\n", NAME,
 			    netif->name, str_error(rc));
-			measured_strings_destroy(&netif->configuration, free);
-			netifs_exclude_index(&net_globals.netifs, index, free);
-			continue;
+			measured_strings_destroy(&netif->configuration);
+			netifs_exclude_index(&net_globals.netifs, index);
+			
+			return rc;
 		}
 		
Index: uspace/srv/net/nil/eth/eth.c
===================================================================
--- uspace/srv/net/nil/eth/eth.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/net/nil/eth/eth.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -214,5 +214,5 @@
 	if (rc != EOK) {
 		free(eth_globals.broadcast_addr);
-		eth_devices_destroy(&eth_globals.devices, free);
+		eth_devices_destroy(&eth_globals.devices);
 	}
 out:
@@ -531,5 +531,5 @@
 			    proto->service);
 		} else {
-			/* Drop invalid/unknown */
+			// drop invalid/unknown
 			pq_release_remote(eth_globals.net_phone,
 			    packet_get_id(packet));
Index: uspace/srv/net/tl/tcp/tcp.c
===================================================================
--- uspace/srv/net/tl/tcp/tcp.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/net/tl/tcp/tcp.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -299,8 +299,7 @@
 		return tcp_release_and_return(packet, NO_DATA);
 
-#if 0
-	printf("header len %d, port %d \n", TCP_HEADER_LENGTH(header),
-	    ntohs(header->destination_port));
-#endif
+//      printf("header len %d, port %d \n", TCP_HEADER_LENGTH(header),
+//	    ntohs(header->destination_port));
+
 	result = packet_get_addr(packet, (uint8_t **) &src, (uint8_t **) &dest);
 	if (result <= 0)
@@ -1063,5 +1062,5 @@
 	tcp_process_acknowledgement(socket, socket_data, header);
 
-	socket_data->next_incoming = ntohl(header->sequence_number); /* + 1; */
+	socket_data->next_incoming = ntohl(header->sequence_number);	// + 1;
 	pq_release_remote(tcp_globals.net_phone, packet_get_id(packet));
 	socket_data->state = TCP_SOCKET_ESTABLISHED;
@@ -1708,5 +1707,5 @@
 		if (socket->port > 0) {
 			socket_ports_exclude(&tcp_globals.sockets,
-			    socket->port, free);
+			    socket->port);
 			socket->port = 0;
 		}
@@ -2493,5 +2492,5 @@
 	rc = packet_dimensions_initialize(&tcp_globals.dimensions);
 	if (rc != EOK) {
-		socket_ports_destroy(&tcp_globals.sockets, free);
+		socket_ports_destroy(&tcp_globals.sockets);
 		goto out;
 	}
Index: uspace/srv/net/tl/tcp/tcp.h
===================================================================
--- uspace/srv/net/tl/tcp/tcp.h	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/net/tl/tcp/tcp.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -190,4 +190,7 @@
 	int backlog;
 	
+//	/** Segment size. */
+//	size_t segment_size;
+
 	/**
 	 * Parent listening socket identifier.
Index: uspace/srv/net/tl/udp/udp.c
===================================================================
--- uspace/srv/net/tl/udp/udp.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/net/tl/udp/udp.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -417,5 +417,5 @@
 	rc = packet_dimensions_initialize(&udp_globals.dimensions);
 	if (rc != EOK) {
-		socket_ports_destroy(&udp_globals.sockets, free);
+		socket_ports_destroy(&udp_globals.sockets);
 		fibril_rwlock_write_unlock(&udp_globals.lock);
 		return rc;
@@ -434,5 +434,5 @@
 	    &data);
 	if (rc != EOK) {
-		socket_ports_destroy(&udp_globals.sockets, free);
+		socket_ports_destroy(&udp_globals.sockets);
 		fibril_rwlock_write_unlock(&udp_globals.lock);
 		return rc;
@@ -499,9 +499,5 @@
 	device_id_t device_id;
 	packet_dimension_t *packet_dimension;
-	size_t size;
 	int rc;
-
-	/* In case of error, do not update the data fragment size. */
-	*data_fragment_size = 0;
 	
 	rc = tl_get_address_port(addr, addrlen, &dest_port);
@@ -543,14 +539,4 @@
 		packet_dimension = &udp_globals.packet_dimension;
 //	}
-
-	/*
-	 * Update the data fragment size based on what the lower layers can
-	 * handle without fragmentation, but not more than the maximum allowed
-	 * for UDP.
-	 */
-	size = MAX_UDP_FRAGMENT_SIZE;
-	if (packet_dimension->content < size)
-	    size = packet_dimension->content;
-	*data_fragment_size = size;
 
 	/* Read the first packet fragment */
@@ -800,12 +786,13 @@
 				break;
 			
-			size = MAX_UDP_FRAGMENT_SIZE;
 			if (tl_get_ip_packet_dimension(udp_globals.ip_phone,
 			    &udp_globals.dimensions, DEVICE_INVALID_ID,
 			    &packet_dimension) == EOK) {
-				if (packet_dimension->content < size)
-					size = packet_dimension->content;
+				SOCKET_SET_DATA_FRAGMENT_SIZE(answer,
+				    packet_dimension->content);
 			}
-			SOCKET_SET_DATA_FRAGMENT_SIZE(answer, size);
+
+//			SOCKET_SET_DATA_FRAGMENT_SIZE(answer,
+//			    MAX_UDP_FRAGMENT_SIZE);
 			SOCKET_SET_HEADER_SIZE(answer, UDP_HEADER_SIZE);
 			answer_count = 3;
Index: uspace/srv/vfs/vfs_ops.c
===================================================================
--- uspace/srv/vfs/vfs_ops.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/vfs/vfs_ops.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -611,5 +611,5 @@
 void vfs_open_node(ipc_callid_t rid, ipc_call_t *request)
 {
-	/* FIXME: check for sanity of the supplied fs, dev and index */
+	// FIXME: check for sanity of the supplied fs, dev and index
 	
 	/*
@@ -1234,5 +1234,4 @@
 	if (!parentc) {
 		fibril_rwlock_write_unlock(&namespace_rwlock);
-		vfs_node_put(old_node);
 		async_answer_0(rid, rc);
 		free(old);
@@ -1252,5 +1251,4 @@
 	if (rc != EOK) {
 		fibril_rwlock_write_unlock(&namespace_rwlock);
-		vfs_node_put(old_node);
 		async_answer_0(rid, rc);
 		free(old);
@@ -1263,5 +1261,4 @@
 	    (old_node->devmap_handle != new_par_lr.triplet.devmap_handle)) {
 		fibril_rwlock_write_unlock(&namespace_rwlock);
-		vfs_node_put(old_node);
 		async_answer_0(rid, EXDEV);	/* different file systems */
 		free(old);
@@ -1282,5 +1279,4 @@
 		if (!new_node) {
 			fibril_rwlock_write_unlock(&namespace_rwlock);
-			vfs_node_put(old_node);
 			async_answer_0(rid, ENOMEM);
 			free(old);
@@ -1294,5 +1290,4 @@
 	default:
 		fibril_rwlock_write_unlock(&namespace_rwlock);
-		vfs_node_put(old_node);
 		async_answer_0(rid, ENOTEMPTY);
 		free(old);
@@ -1305,5 +1300,4 @@
 	if (rc != EOK) {
 		fibril_rwlock_write_unlock(&namespace_rwlock);
-		vfs_node_put(old_node);
 		if (new_node)
 			vfs_node_put(new_node);
Index: version
===================================================================
--- version	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ version	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -37,5 +37,5 @@
 VERSION = 0
 PATCHLEVEL = 4
-SUBLEVEL = 3
+SUBLEVEL = 2
 
 ifdef EXTRAVERSION
@@ -45,3 +45,3 @@
 endif
 
-NAME = Sashimi
+NAME = Skewer
